import Editor from '@modules/editor';
import { IObjectClickService, IOrbitControlService, ITransformControlService } from '@modules/editor/service/control';
import * as THREE from 'three';
export type Services = {
    TransformControlService: ITransformControlService;
    ObjectClickService: IObjectClickService;
    OrbitControlService: IOrbitControlService;
};
declare class EditorControl {
    #private;
    constructor(editor: Editor, services: Services);
    private set isObjectDragging(value);
    private set orbitControlOnOff(value);
    init(): void;
    turnOffObjectClickEvent(): void;
    turnOnObjectClickEvent(): void;
    attachTransform(validObj: THREE.Object3D<THREE.Event>): void;
    detachTransform(): void;
    setTransformMode(mode: 'translate' | 'rotate' | 'scale'): void;
    removeClickedObject(): void;
}
export default EditorControl;
