import Editor from '@modules/editor';
import { IGeometryService, IGridService } from '@modules/editor/service/geometry';
import { GRID_HELPER_GROUP } from '@modules/editor/constants/name';

type Services = { GridService: IGridService; GeometryService: IGeometryService };

class EditorGeometry {
  #Editor: Editor;
  #Services: Services;

  constructor(editor: Editor, services: Services) {
    this.#Editor = editor;
    this.#Services = services;
  }

  public init() {
    const { scene } = this.#Editor;

    this.#Services.GridService.setGrid(scene, { gridGroupName: GRID_HELPER_GROUP });
    this.#Services.GeometryService.setCube(scene);
  }
}

export default EditorGeometry;
